=== debian/changelog ===
ats2-lang (0.1.3-1) unstable; urgency=low

  * New upstream release

 -- Matthew Danish <mrd@debian.org>  Thu, 02 Oct 2014 12:39:50 -0400

ats2-lang (0.1.2-1) unstable; urgency=low

  * New upstream release

 -- Matthew Danish <mrd@debian.org>  Fri, 19 Sep 2014 13:23:56 -0400
